#ifndef __INC_POS_PDOS_DOSTAGS_H
#define __INC_POS_PDOS_DOSTAGS_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>DosTags.h<<   31 Jan 1997    09:32:25 - (C) ProDAD
*******************************************************************/
#ifndef __INC_POS_PUTIL_TAGITEM_H
#include <pUtil/TagItem.h>
#endif

enum pOS_DosTags
{
  DOSTAG_First = TAG_USER + 0x30000,

  DOSTAG_Name,          /* (const CHAR*) Default: Background Process */
  DOSTAG_StackSize,     /* (size_t)  Default: 8192 */
  DOSTAG_Priority,      /* (SLONG)   Default: 0 */
  DOSTAG_SegList,       /* (pOS_SegmentLst*) Default: NULL */
  DOSTAG_Entry,         /* (VOID(*)(pOS_DosBase*)) Default: NULL */
  DOSTAG_Data1,         /* (ULONG) Default: 0 */
  DOSTAG_Arguments,     /* (const CHAR*) Default: NULL */
  DOSTAG_ProcNum,       /* (ULONG) Default: -2 */
  DOSTAG_ProcFlags,     /* (enum pOS_ProcessFlags) Default: 0 */
  DOSTAG_Synchronous,   /* (BOOL) Default: FALSE */
  DOSTAG_SizeofProcess, /* (size_t) sizeof(pOS_Process) <only private for internal> */
  DOSTAG_InputFH,       /* (pOS_FileHandle*) */
  DOSTAG_OutputFH,      /* (pOS_FileHandle*) */
  DOSTAG_ErrorFH,       /* (pOS_FileHandle*) */
  DOSTAG_ConsoleFH,     /* (pOS_FileHandle*) */
  DOSTAG_CurrDirLock,   /* (pOS_FileLock*) */
  DOSTAG_Script,        /* (BOOL) Default: FALSE */
  DOSTAG_ScriptFile,    /* (const dofiname*) incl. DOSTAG_Script=TRUE */
  DOSTAG_ScriptSnoop,   /* (BOOL) Default: FALSE */
  DOSTAG_DupFHs,        /* (BOOL) Default: FALSE, alle FH vom CreateProcess zum neuen bertragen */
  DOSTAG_DefaultProc,   /* (BOOL) Default: TRUE, fr CIS,COS,CES,CurrDir,... werden nur Defaults verwendet */
  DOSTAG_DupPath,       /* (BOOL) Default: FALSE, alle PATH-Daten bernehmen */
  DOSTAG_DupAlias,      /* (BOOL) Default: FALSE, alle ALIAS-Daten bernehmen */
  DOSTAG_DupVars,       /* (BOOL) Default: FALSE, alle VARIABLE-Daten bernehmen */
  DOSTAG_CrtHomeShell,  /* (BOOL) Default: FALSE, create pr_HomeShell */
  DOSTAG_ProgDirLock,   /* (pOS_FileLock*) */
  DOSTAG_VolumeSize,    /* (size_t) ByteSize von pOS_DosDevice + private Daten
                        ** fr pOS_OpenDOSVolumeA() und pOS_CreateDOSVolumeA()
                        **/
};


#endif
